#include <stdio.h>
#include <stdlib.h>     // for exit()
#include <string.h>     // for strlen()
#include "ser_buff.h"

Circ_buff test_buff;

int main(void) {
    unsigned char index;
    char input;
    unsigned char return_val;
    char data;
    char buff[1000];
   
    init_buffer( &test_buff );

    while( 1 ) {
        printf( "%i bytes free in buffer\n", get_avail_space( &test_buff ) );
        printf( "read_pos = %i, write_pos = %i\n",
                test_buff.read_pos, test_buff.write_pos);

        scanf( "%c%*c", &input );

        switch( input ) {
            case 'e':
            case 'q':
                exit(0);
                break;
            case 'r':
                printf( "reading from buffer:" );
                return_val = read_char(&test_buff, &data);
                if( return_val == BMESG_NO_DATA )
                    printf( "error, no data available!\n" );
                else if( return_val == BMESG_SUCCESS )
                    printf( ">>%c<< read\n", data );
                else
                    printf( "invalid code received: %i\n", return_val );
                break;
            case 'w':
                printf( "enter some data to write:" );
                scanf( "%1000s%*c", buff );
                printf( "%i characters received, writing:\n", strlen(buff) );
                return_val = write_string( &test_buff, buff, strlen(buff) );
                if( return_val == BMESG_NOT_ENOUGH_SPACE )
                    printf( "error, data cannot fit!\n" );
                else if( return_val == BMESG_SUCCESS )
                    printf( "writing a success!\n" );
                else
                    printf( "invalid code received: %i\n", return_val );
                break;
            case '1':
                printf( "adding large amount of data: " );
                for(index = 0; index < BUFFER_LENGTH -1; index++)
                    buff[index] = (index & 0xF) + '0';
                buff[BUFFER_LENGTH-5] = 0x0;
                printf( "%i characters received, writing:\n", strlen(buff) );
                return_val = write_string( &test_buff, buff, strlen(buff) );
                if( return_val == BMESG_NOT_ENOUGH_SPACE )
                    printf( "error, data cannot fit!\n" );
                else if( return_val == BMESG_SUCCESS )
                    printf( "writing a success!\n" );
                else
                    printf( "invalid code received: %i\n", return_val );
                break;
            case '2':
                printf("reading out buffer: >>");
                while( get_avail_space(&test_buff) < (BUFFER_LENGTH - 1) ) {
                    return_val = read_char(&test_buff, &data);
                    if( return_val == BMESG_NO_DATA ) {
                        printf( "error, no data available!\n" );
                        break;
                    }
                    else if( return_val == BMESG_SUCCESS )
                        printf( "%c", data );
                    else {
                        printf( "invalid code received: %i\n", return_val );
                        break;
                    }    
                }
                printf("<<\n");
                break;

            default:
                printf( "character >>%c<< not understood\n", input );
                break;
        }
    }

    return 0;
}
